package org.jboss.jtademo;

import javax.transaction.*;

import java.sql.*;

public class Example2 {

	public static void main(String[] args) throws Exception {
		AS as = new AS();
		TransactionManager tm = as.getTM();

		// TX1
		System.out.println("TX1");
		tm.begin();
		Connection conn1 = as.getConnection();
		conn1.createStatement().execute("insert into JTAEX values ('ex2-tx1')");
		System.out.println("JTA status: " + Util.convertTransactionStatus(tm.getStatus()));
		Transaction t1 = tm.suspend();
		System.out.println("JTA status: " + Util.convertTransactionStatus(tm.getStatus()));
		System.out.println("Susp JTA status: " + Util.convertTransactionStatus(t1.getStatus()));

		// TX2
		System.out.println("TX2");
		tm.begin();
		System.out.println("JTA status: " + Util.convertTransactionStatus(tm.getStatus()));
		Connection conn2 = as.getConnection();
		conn2.createStatement().execute("insert into JTAEX values ('ex2-tx2')");
		as.close(conn2);
		tm.commit();
		System.out.println("Check contents of JTAEX table");
		System.in.read();

		// TX1
		System.out.println("Back to TX1");
		tm.resume(t1);
		System.out.println("JTA status: " + Util.convertTransactionStatus(tm.getStatus()));
		as.close(conn1);
		tm.commit();
		System.out.println("Check contents of JTAEX table");
	}
}
